#!/usr/bin/perl

use strict;

my $plotfile;
my $in_file;
my $out_file;
my $out_dir;
my $in_date;
my $in_datarate;

my $ot_template = 'c:\iperf\plot_tpl_output_time.txt';
my $pgnuplot_cmd = 'c:\gnuplot\bin\pgnuplot.exe';
my $out_eps;
my $out_png;
my $out_scr;

if ($#ARGV < 3) {
	printf ("USAGE: $0 DAT-File OUTPUT-DIR DATE INPUTDATARATE\n\n");
	exit 0;
} else {

	# Get input file
	if (-r $ARGV[0]) {
	        $in_file = $ARGV[0];
	        # Gnuplot nutzt "/" als Verzeichnis Splitter und nicht "\"!
	        $in_file =~ s/\\/\//g;
	} else {
	        die "Can't open $ARGV[0]!\n\n";
	}

        # Get Output dir
        if (-d $ARGV[1]) {
        	$out_dir = $ARGV[1];
                $out_dir =~ s/\\/\//g;
        } else {
        	die "Can't find $ARGV[1] as output directory!\n\n";
	}

        # Get Date
       	if ($ARGV[2] =~ /\d{4}-\d{2}-\d{2}/) {
         	$in_date = $ARGV[2];
        } else {
        	die "Date format not ok. Please use format yyyy-mm-dd\n\n";
        }

        # Get Datarate text
        $in_datarate = $ARGV[3];

	# Check directories
        if (-d $out_dir) {
        	if (!(-d "$out_dir/EPS")) { mkdir("$out_dir/EPS"); }
                if (!(-d "$out_dir/PLOTSCRIPT")) { mkdir ("$out_dir/PLOTSCRIPT"); }
       	}

	# GENERATE Output-Time PLOT
        # Load plot template file
	open (TMPL, "< $ot_template") or die "Cant open $ot_template\n\n";
	while (<TMPL>) {
	        $plotfile .= $_;
	}
	close TMPL;

	my $title = sprintf("%s %s", $in_date, $in_datarate);
        $out_file = sprintf("%s/%s", $out_dir, "OUTPUT-TIME-".$in_date);

        $out_eps = sprintf("%s/EPS/%s.eps", $out_dir, "OUTPUT-TIME-".$in_date);
        $out_png = sprintf("%s/%s.png", $out_dir, "OUTPUT-TIME-".$in_date);
        $out_scr = sprintf("%s/PLOTSCRIPT/%s.txt", $out_dir, "OUTPUT-TIME-".$in_date);

        $plotfile =~ s/\$title/$title/g;
        $plotfile =~ s/\$infile/$in_file/g;
        $plotfile =~ s/\$OUTPNG/$out_png/g;
        $plotfile =~ s/\$OUTEPS/$out_eps/g;

#        printf ("EPS: %s\n", $out_eps);
#        printf ("PNG: %s\n", $out_png);
#        printf ("SCR: %s\n", $out_scr);

        open (PLOT, "| $pgnuplot_cmd") or die "Can't open pgnuplot.exe\n\n";
        print PLOT $plotfile;
        close (PLOT);

        # Plot Script auch ins Output Dir schreiben!
        open (SC, " > $out_scr") or die "Can't open $out_scr\n\n";
        print SC $plotfile;
        close (SC);


} # END IF ELSE