#!/usr/bin/perl

use strict;
use Net::Ping;

my $p;
my $logfile;
my $host;
my $size;

#my $counter;
my @latency;
my @time;

my @res;
my $tmpCnt;
my $tmpRes;
my $tmpMid;
my $date;
my $tmpLogfile;
my $lastHour;
my $strHeader;

my $sum1;
my $sum2;

my $stdDev;
my $var;
my $mid;
my $num;
my $cInt90;
my $cInt95;
my $cInt99;

my $pingCount = 1;      	# Pings send to host
my $sleepSeconds = 1; 		# Seconds
my $debugOutput = 15; 		# Seconds
my $statOutputMinute = 0;       # Write Output to file on mm (hh:mm)

if ($#ARGV<1) {
	print ("USAGE: $0 LOGFILE HOST <SIZE>\n\n");
        print ("LOGFILE: Path + LogFilePrefix\n");
        print ("HOST: IP-Address of Host like 192.168.0.21\n");
        print ("\n");

} else {

	$logfile = $ARGV[0];
        $host = $ARGV[1];
        $size = $ARGV[2];

	if (!($host =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/)) {
         	printf("HOST: $host is not an IP!\n");
                goto EXIT;
        }

#        open (OUT, ">> $logfile") or die "Can't open $logfile for append!\n";
#        close (OUT);

        if (($size < 1) or ($size >1024)) {
        	printf ("Set size to 1024 Bytes\n");
                $size = 1024;  # Default Size
	}

	$p = Net::Ping->new("icmp",5,$size);
	$p->hires(1);

	my $test = 11.28373282;
	undef @latency;
        while(1) {

                $tmpRes = 0;
                $tmpCnt = 0;
                $tmpMid = 0;

                # Make ping test
                for (my $i=0; $i <= $pingCount; $i++) {
                        @res = $p->ping($host);
                        if ($res[0]!=1) {
                                $res[1]=0;
                        }
                        if ($res[1]>0) {
                                $tmpRes += $res[1];
                                $tmpCnt++;
                        }
                }

               # Add current latency to latency
                if ($tmpCnt>0) {
                        $tmpMid = ($tmpRes/$tmpCnt)*1000;
                        push(@latency, $tmpMid);
                }
                # else RESULT SKIPPED!

                # Get current time
	        @time = localtime(time);

               	$date = sprintf("%d%02d%02d", (1900+$time[5]), (1+$time[4]), $time[3]);

                $tmpLogfile = sprintf("%s_%s_%s.txt", $logfile,"RAW", $date);
                open (OUTRAW, ">> $tmpLogfile") or die "Can't open $tmpLogfile for append!\n";
                printf OUTRAW ("%d %02d:%02d:%02d %15d %12.8f\n", $date,$time[2], $time[1], $time[0], time, $tmpMid);
                close (OUTRAW);


                if ($time[2] == 0) {
                 	$time[2] = 24;	# sonst wird 23 Uhr in -1 umgewandelt!
                        $time[3] = $time[3] -1; # Stunde gehrt noch zum Vortag!
                }
               	$date = sprintf("%d%02d%02d", (1900+$time[5]), (1+$time[4]), $time[3]);

                # write to logfile every new hour
                $num = $#latency+1;
                if (($time[1] == $statOutputMinute) and ($lastHour != $time[2]-1) and ($num > 1)) {

                	$var = 0;

                        $sum1 = 0;
                        $sum2 = 0;
                        $stdDev = 0;
                        $mid = 0;
                        $cInt90 = 0;
                        $cInt95 = 0;
                        $cInt99 = 0;

                	# Mittelwert berechnen.
                        for (my $i=0; $i < $num; $i++) {
				$sum1 += $latency[$i];
                        }

                        # Mittelwert
                        $mid = $sum1 / $num;

                        for (my $i=0; $i < $num; $i++) {
                         	$sum2 += (($latency[$i]-$mid)*($latency[$i]-$mid));
                        }

                        # Varianz und Standardabweichung
                        $var = ( (1/($num-1)) * $sum2);
                        $stdDev = sqrt($var);

                        # Konfidenzintervall

                        $cInt90 = (1.645 * $stdDev)/sqrt($num);
                        $cInt95 = (1.960 * $stdDev)/sqrt($num);
                        $cInt99 = (2.576 * $stdDev)/sqrt($num);

                	$tmpLogfile = sprintf("%s_%s.txt", $logfile, $date);
                        if (!(-R $tmpLogfile)) {
                        	$strHeader = sprintf("%-8s  %-2s  %-10s  %-5s %-10s %-10s %-10s %-10s %-10s\n", "#DATE", "HOUR", "Middle", "COUNT", "VARIANCE", "STD.DEV.", "CI 90%", "CI 95%", "CI 99%");
                                $strHeader .= ("#-------------------------------------------------------------------------------------\n");
                        }
                        open (OUT, ">> $tmpLogfile") or die "Can't open $tmpLogfile for append!\n";
                        if (defined $strHeader) { print OUT $strHeader; undef $strHeader;}
                	printf OUT ("%8d  %02d  %10.6f  %5d %10.6f %10.6f %10.6f %10.6f %10.6f\n", $date, ($time[2]-1), $mid, $num, $var, $stdDev, $cInt90, $cInt95, $cInt99);
                      	close (OUT);

#                        $tmpLogfile = sprintf("%s_%s_%s.txt", $logfile,"RAW", $date);
#                        open (OUTRAW, ">> $tmpLogfile") or die "Can't open $tmpLogfile for append!\n";
#                        foreach $tmpRes (@latency) {
#                                printf OUTRAW ("%-12d %15d %10.8f\n", $date, time, $tmpRes);
#                        }
#                        close (OUTRAW);

                        $lastHour = $time[2]-1;

                        printf ("--------------------------------------------------------------------------\n");
                	printf ("%8d  %02d  %10.6f  %5d %10.6f %10.6f %10.6f %10.6f %10.6f\n", $date, ($time[2]-1), $mid, $num, $var, $stdDev, $cInt90, $cInt95, $cInt99);
			printf ("--------------------------------------------------------------------------\n");

			undef @latency;
                }

                # DEBUG OUTPUT
                if (($time[0] % 15) == 0) {
	                printf ("[%d %02d:%02d:%02d] %s => %10.6f ms.\n", $date,$time[2], $time[1], $time[0], $host, $tmpMid);
                }
	        sleep ($sleepSeconds-($time[0] % $sleepSeconds));
        }

EXIT:

} # END